var cx = document.getElementById('colors').getContext('2d');
var step;
var steps = jQuery.map(data.areas, function(a) {
	if ((a.clicking !='')){
		return a.clicking;
	}
});
steps = $.unique(steps).length;

$(document).ready(function() {

	// Load and fill data
	$("#app>h1").text(data.title);
	$("#app>h2").text(data.subtitle);

	// Immagini 
	$("#layer1").attr("src","media/img/" + data.layer1);
	$("#colors").attr("width", data.layer_width).attr("height", data.layer_height);

	// Areas
	$.each(data.areas, function( index, value ) {	  
		var _html = '<area clicking="' + value.clicking + '" shape="poly" coords="' + value.coords + '" href="#">';
		$("#shapes").append(_html);
	});	
	initAreas();
    
	$("#hotspots").width($("#colors").attr("width"));
	$("#hotspots").height($("#colors").attr("height")); 

	$("#colors").animate({opacity: 0.5});
	$("#b_reset").trigger("click");  
});

function playSound(_id){
  $.each($('audio'), function () {
      document.getElementById($(this).attr("id")).pause();
      try {
        document.getElementById($(this).attr("id")).currentTime = 0;     
      } catch (e) {
        // iOS bug
      } 
  });
  document.getElementById(_id).play();
}

function initAreas(){
	$("#shapes area").click(function(e){
	  e.preventDefault();
	  $("#wrong").hide();
	  if($(this).attr("clicking") != ""){
	    if($(this).attr("clicked") == "false"){ // Per evitare click multipli sullo stesso
			playSound("ok");
			var c = $(this).attr("clicking");
			$.each($("#shapes area"), function () {
				if($(this).attr("clicking") == c){
					$(this).attr("clicked","true");
					color($(this));
				}
			});		
			step++;
			if(step>steps){
			  $("#b_answer").hide();
			  $("h3").fadeIn("fast");
			}
		}
	  }else{
		playSound("ko");
		
		var coords = $(this).attr("coords").split(",");
		var x = 0;
		var y = 0;
		for(i=0; i<coords.length; i++){
		  if (i%2==0){ // pari x
			x += parseFloat(coords[i]);
		  }
		  if(i%2==1){
			y += parseFloat(coords[i]);
		  }
		}
		x = x/(coords.length/2)-25;
		y = y/(coords.length/2)-25+100;
		
		$("#wrong").css("top",y).css("left",x).show();    
	  }
	});
}

function color(_this){
  var coords = _this.attr("coords").split(",");
  cx.fillStyle = '#6c397a';
  cx.beginPath();
  cx.moveTo(parseFloat(coords[0]), parseFloat(coords[1]))      
  for(i=2; i<coords.length; i+=2){
    cx.lineTo(parseFloat(coords[i]), parseFloat(coords[i+1]));
  }
  cx.closePath();
  cx.fill();
}

$("#b_info").click(function(e){ 
	e.preventDefault();
    mw_mask = 'background:#000;height:100%;opacity:0.75;position:fixed;top:0;left:0;width:100%;z-index:1000;cursor:pointer';
    mw_win = 'background:#fff;position:fixed;top:20px;left:50%;margin-left:-385px;z-index:1001;width:770px;height:580px;cursor:pointer';
    $('head').append('<style id="mw_style">#mw_mask{'+mw_mask+'}#mw_win{'+mw_win+'}</style>');
    $('body').append('<div id="mw_mask"></div><img id="mw_win" src="media/img/help.jpg"/>');
    $('#mw_mask, #mw_win').unbind('click').bind('click', function() {$('#mw_win,#mw_mask,#mw_style').remove()});
});

$("#b_answer").click(function(e){ 
	e.preventDefault();
    $("#b_reset").trigger("click");
    $("#shapes area").each(function(index){
      if($(this).attr("clicking")!=""){     
        color($(this));
      }
    });
    $("#hotspots").hide();
    $("#b_answer").addClass("clicked");
});

$("#b_reset").click(function(e){ 
	e.preventDefault();
	cx.clearRect(0, 0, $("#colors").attr("width"), $("#colors").attr("height"));
	step = 1;
	$("#shapes area").each(function(){
		$(this).attr("clicked","false");
	});		
	$("#hotspots, #b_answer").show();
	$("#b_answer").removeClass("clicked");
	$("#wrong, h3").hide();
});